## foma 0.9.18%2Br243

=== debian/changelog ===
foma (0.9.18+r243-1) unstable; urgency=medium

  * Initial release (Closes: #809735)

 -- Timo Jyrinki <timo@debian.org>  Mon, 08 Feb 2016 11:11:27 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --fail-missing

override_dh_auto_configure:
	touch NEWS
	dh_auto_configure

override_dh_auto_install:
	dh_auto_install

	# Remove libtool-like files
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.la
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a

## foma 0.9.18+r243

=== Makefile ===
prefix = /usr/local
exec_prefix = $(prefix)
libdir = $(exec_prefix)/lib
bindir = $(exec_prefix)/bin
includedir = $(prefix)/include

VERSION = 0.9.18
SVN_REV = $(shell svn info | grep "Last Changed Rev" | cut -f4 -d\ )
CC = gcc
RANLIB = ranlib
YACC = bison -v
LEX = flex -8
LEXCLEX = flex -8 --prefix=lexc
LEXIFACE = flex -8 --prefix=interface
LEXCMATRIX = flex -8 --prefix=cmatrix
RM = /bin/rm -f
LDFLAGS = -lreadline -lz -ltermcap
FLOOKUPLDFLAGS = libfoma.a -lz
CFLAGS = -O3 -Wall -D_GNU_SOURCE -std=c99 -fvisibility=hidden -fPIC -mmacosx-version-min=10.6 -DSVN_REV=$(SVN_REV)
FOMAOBJS = foma.o stack.o iface.o lex.interface.o
LIBOBJS = int_stack.o define.o determinize.o apply.o rewrite.o lexcread.o topsort.o flags.o minimize.o reverse.o extract.o sigma.o io.o structures.o constructions.o coaccessible.o utf8.o spelling.o dynarray.o mem.o stringhash.o trie.o lex.lexc.o lex.yy.o lex.cmatrix.o regex.o

all: libfoma foma flookup cgflookup

foma: $(FOMAOBJS) $(LIBOBJS)
	$(CC) $(CFLAGS) $(FOMAOBJS) $(LIBOBJS) $(LDFLAGS) -o $@

flookup: flookup.o libfoma
	$(CC) $(CFLAGS) flookup.o $(FLOOKUPLDFLAGS) -o $@

cgflookup: cgflookup.o libfoma
	$(CC) $(CFLAGS) cgflookup.o $(FLOOKUPLDFLAGS) -o $@

STATICLIB = libfoma.a

UNAME := $(shell uname)

ifeq ($(UNAME), Darwin)
	SHAREDLIB = libfoma.dylib
	SHAREDLIBV = libfoma.$(VERSION).dylib
	SHAREDLIBM = libfoma.0.dylib
	AR = libtool
	ARFLAGS = -static -o
	DFLAG = -dylib_install_name
else 
	SHAREDLIB = libfoma.so
	SHAREDLIBV = libfoma.so.$(VERSION)
	SHAREDLIBM = libfoma.so.0
	AR = ar
	ARFLAGS = cru
	DFLAG = -soname
endif

ifeq ($(UNAME), SunOS)
	DFLAG = -h
	FLOOKUPLDFLAGS = libfoma.a -lz -lsocket -lnsl
endif

ifeq ($(UNAME), CYGWIN_NT-5.1)
	LDFLAGS = /usr/lib/libreadline.dll.a /usr/lib/libz.a
	FLOOKUPLDFLAGS = libfoma.a /usr/lib/libz.a
endif

LIBS = $(SHAREDLIBV) $(STATICLIB)

libfoma: $(SHAREDLIBV)

$(SHAREDLIBV): $(LIBOBJS)
	$(AR) $(ARFLAGS) $(STATICLIB) $(LIBOBJS)
	$(RANLIB) $(STATICLIB)
	$(CC) $(CFLAGS) -shared -Wl,$(DFLAG),$(SHAREDLIBM) -o $(SHAREDLIBV) $(LIBOBJS) $(LDFLAGS)

install: foma libfoma
	-@if [ ! -d $(exec_prefix) ]; then mkdir -p $(exec_prefix); fi
	-@if [ ! -d $(includedir)  ]; then mkdir -p $(includedir); fi
	-@if [ ! -d $(libdir)      ]; then mkdir -p $(libdir); fi
	-@if [ ! -d $(bindir)      ]; then mkdir -p $(bindir); fi
	cp fomalib.h fomalibconf.h $(includedir);
	chmod 644 $(includedir)/fomalib.h
	cp foma flookup cgflookup $(bindir)
	cp $(LIBS) $(libdir)
	cd $(libdir); chmod 755 $(LIBS); \
	if test -f $(libdir)/$(SHAREDLIB); then rm  $(libdir)/$(SHAREDLIB); fi
	if test -f $(libdir)/$(SHAREDLIBM); then rm  $(libdir)/$(SHAREDLIBM); fi
	cd $(libdir); ln -s $(SHAREDLIBV) $(SHAREDLIB); cd $(libdir);	\
	ln -s $(SHAREDLIBV) $(SHAREDLIBM); (ldconfig || true)		\
	>/dev/null 2>&1; \

$(OBJS): foma.h

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

lex.yy.c: regex.l regex.h
	$(LEX) regex.l

lex.lexc.c: lexc.l
	$(LEXCLEX) $<

lex.interface.c: interface.l
	$(LEXIFACE) $<

lex.cmatrix.c: cmatrix.l
	$(LEXCMATRIX) $<

regex.c regex.h: regex.y
	$(YACC) --defines=$*.h --output=$*.c $<

clean:
	$(RM) foma flookup cgflookup $(FOMAOBJS) $(LIBOBJS) flookup.o cgflookup.o regex.h regex.c regex.output lex.yy.c lex.lexc.c lex.interface.c lex.cmatrix.c *.so* *.dylib* *.a

=== debian/changelog ===
foma (1:0.9.18+r243-8) unstable; urgency=low

  [ Tino Didriksen ]
  * Drop parallel builds again (Closes: #916192)

 -- Kartik Mistry <kartik@debian.org>  Thu, 09 Jul 2020 22:11:25 +0530

foma (1:0.9.18+r243-7) unstable; urgency=low

  [ Tino Didriksen ]
  * Patch to fix FTBFS with GCC 10 (Closes: #957216)
  * debian/control:
    + Updated dh to 13
    + Updated Standards-Version to 4.5.0

  [ Kartik Mistry ]
  * Added debian/upstream/metadata.
  * Fixed debian/debian/gitlab-ci.yml format.
  * debian/rules:
    + Added Hardening support.

 -- Kartik Mistry <kartik@debian.org>  Mon, 06 Jul 2020 14:13:22 +0530

foma (1:0.9.18+r243-6) unstable; urgency=medium

  * Team upload.
  * Drop parallel builds.
    Thanks to Adrian Bunk (Closes: #916192)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 24 Apr 2019 15:53:09 +0200

foma (1:0.9.18+r243-5) unstable; urgency=low

  * debian/control:
    + Add epoch in Breaks/Replaces (Closes: #904396). Thanks Andreas Beckmann.

 -- Kartik Mistry <kartik@debian.org>  Wed, 12 Dec 2018 09:44:42 +0530

foma (1:0.9.18+r243-4) unstable; urgency=low

  * debian/control:
    + Added old packages as transitional packages to fix upgrade.
      (Closes: #904396)
    + Readded Timo Jyrinki <timo@debian.org> as Maintainer, was
      dropped by mistake!

 -- Kartik Mistry <kartik@debian.org>  Mon, 10 Dec 2018 20:31:04 +0530

foma (1:0.9.18+r243-3) unstable; urgency=low

  * debian/control:
    + Added Breaks/Replaces for libfoma0-dev and foma.
    + Fixed Multi-Arch fields.
  * debian/rules:
    + Fixed MULTIARCH installation.
    + Remove Hardening rules, breaks build as of now.
  * Updated debian/patches/foma_02_Makefile.diff from previous version.

 -- Kartik Mistry <kartik@debian.org>  Mon, 03 Dec 2018 18:18:24 +0530

foma (1:0.9.18+r243-2) unstable; urgency=low

  * Upload to unstable:
    + Bring 0.9.18+r243 upstream version back.
  * debian/control:
    + Updated Standards-Version to 4.2.1
    + Updated description for binaries.
  * Added debian/watch file.
  * debian/patches/foma_02_Makefile.diff:
    + Do not add !Linux option in CFLAG.

 -- Kartik Mistry <kartik@debian.org>  Mon, 03 Dec 2018 16:41:38 +0530

foma (1:0.9.18~r248-1) experimental; urgency=low

  * New upstream release snapshot:
    + Added epoch to fix: latest-debian-changelog-entry-without-new-version
  * debian/control:
    + Updated Standards-Version to 4.1.4.
    + Updated Vcs-* fields.
    + Updated Homepage.
    + Use dh 11.
    + Updated Section for libfoma.
  * debian/copyright:
    + Updated URLs.
  * Added patch description.
  * Added Hardening support.
  * Removed debian/libfoma0.postinst.
  * debian/rules:
    + Do not generate -dbg packages, until fixed upstream.

 -- Kartik Mistry <kartik@debian.org>  Thu, 14 Jun 2018 19:31:13 +0530

foma (0.9.18+r243-1) unstable; urgency=low

  * Initial release (Closes: #809735)

 -- Tino Didriksen <mail@tinodidriksen.com>  Mon, 11 Jan 2016 09:27:01 +0100

=== debian/control ===
Source: foma
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
           Timo Jyrinki <timo@debian.org>,
           Kartik Mistry <kartik@debian.org>
Build-Depends: bison,
               debhelper-compat (= 13),
               flex,
               libreadline-dev,
               libtinfo-dev,
               libtool,
               zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://fomafst.github.io/
Vcs-Git: https://salsa.debian.org/science-team/foma.git
Vcs-Browser: https://salsa.debian.org/science-team/foma

Package: foma
Architecture: any
Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: foma-bin (<< 1:0)
Replaces: foma-bin (<< 1:0)
Description: Tools for constructing various finite-state automata
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.

Package: libfoma0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Foma runtime libraries
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides runtime libraries for foma.

Package: libfoma0-dev
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}
Breaks: libfoma-dev (<< 1:0)
Replaces: libfoma-dev (<< 1:0)
Section: libdevel
Description: Foma development files
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides development headers and libraries
 for foma.

Package: foma-bin
Architecture: all
Depends: foma (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package for foma
 This is dummy transitional package for foma. It can be
 safely remove.

Package: libfoma-dev
Architecture: all
Depends: libfoma0-dev (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package for libfoma0-dev
 This is dummy transitional package for libfoma0-dev. It can
 be safely remove.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This has to be exported to make some magic below work.
export DH_OPTIONS

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	touch NEWS
	dh_auto_configure

override_dh_auto_install:
	dh_auto_install

	# Remove libtool-like files
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.la
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
https://bitbucket.org/mhulden/foma/downloads/foma-([\d\.]+)\.tar\.gz

## foma 0.10.0

=== Makefile ===
--- 
+++ 
@@ -3,9 +3,9 @@
 libdir = $(exec_prefix)/lib
 bindir = $(exec_prefix)/bin
 includedir = $(prefix)/include
+pkgcfgdir = $(libdir)/pkgconfig
 
-VERSION = 0.9.18
-SVN_REV = $(shell svn info | grep "Last Changed Rev" | cut -f4 -d\ )
+VERSION = 0.10.0
 CC = gcc
 RANLIB = ranlib
 YACC = bison -v
@@ -16,7 +16,7 @@
 RM = /bin/rm -f
 LDFLAGS = -lreadline -lz -ltermcap
 FLOOKUPLDFLAGS = libfoma.a -lz
-CFLAGS = -O3 -Wall -D_GNU_SOURCE -std=c99 -fvisibility=hidden -fPIC -mmacosx-version-min=10.6 -DSVN_REV=$(SVN_REV)
+CFLAGS = -O3 -Wall -D_GNU_SOURCE -std=c99 -fvisibility=hidden -fPIC
 FOMAOBJS = foma.o stack.o iface.o lex.interface.o
 LIBOBJS = int_stack.o define.o determinize.o apply.o rewrite.o lexcread.o topsort.o flags.o minimize.o reverse.o extract.o sigma.o io.o structures.o constructions.o coaccessible.o utf8.o spelling.o dynarray.o mem.o stringhash.o trie.o lex.lexc.o lex.yy.o lex.cmatrix.o regex.o
 
@@ -61,6 +61,10 @@
 	FLOOKUPLDFLAGS = libfoma.a /usr/lib/libz.a
 endif
 
+ifeq ($(UNAME), MINGW64_NT-10.0-17763)
+	LDFLAGS = -lreadline -lz -lncurses
+endif
+
 LIBS = $(SHAREDLIBV) $(STATICLIB)
 
 libfoma: $(SHAREDLIBV)
@@ -70,14 +74,16 @@
 	$(RANLIB) $(STATICLIB)
 	$(CC) $(CFLAGS) -shared -Wl,$(DFLAG),$(SHAREDLIBM) -o $(SHAREDLIBV) $(LIBOBJS) $(LDFLAGS)
 
-install: foma libfoma
+install: foma libfoma libfoma.pc
 	-@if [ ! -d $(exec_prefix) ]; then mkdir -p $(exec_prefix); fi
 	-@if [ ! -d $(includedir)  ]; then mkdir -p $(includedir); fi
 	-@if [ ! -d $(libdir)      ]; then mkdir -p $(libdir); fi
+	-@if [ ! -d $(pkgcfgdir)   ]; then mkdir -p $(pkgcfgdir); fi
 	-@if [ ! -d $(bindir)      ]; then mkdir -p $(bindir); fi
 	cp fomalib.h fomalibconf.h $(includedir);
 	chmod 644 $(includedir)/fomalib.h
 	cp foma flookup cgflookup $(bindir)
+	cp libfoma.pc $(pkgcfgdir)
 	cp $(LIBS) $(libdir)
 	cd $(libdir); chmod 755 $(LIBS); \
 	if test -f $(libdir)/$(SHAREDLIB); then rm  $(libdir)/$(SHAREDLIB); fi
@@ -87,6 +93,18 @@
 	>/dev/null 2>&1; \
 
 $(OBJS): foma.h
+
+libfoma.pc:
+	echo "prefix=${prefix}" > $@
+	echo 'exec_prefix=$${prefix}' >> $@
+	echo 'includedir=$${prefix}/include' >> $@
+	echo 'libdir=$${exec_prefix}/lib' >> $@
+	echo '' >> $@
+	echo 'Name: foma' >> $@
+	echo 'Description: The foma library' >> $@
+	echo 'Version: ${VERSION}' >> $@
+	echo 'Cflags: -I$${includedir}' >> $@
+	echo 'Libs: -L$${libdir} -lfoma' >> $@
 
 .c.o:
 	$(CC) $(CFLAGS) -c $< -o $@
@@ -103,8 +121,8 @@
 lex.cmatrix.c: cmatrix.l
 	$(LEXCMATRIX) $<
 
-regex.c regex.h: regex.y
+regex.c regex.h: regex.y constructions.o
 	$(YACC) --defines=$*.h --output=$*.c $<
 
 clean:
-	$(RM) foma flookup cgflookup $(FOMAOBJS) $(LIBOBJS) flookup.o cgflookup.o regex.h regex.c regex.output lex.yy.c lex.lexc.c lex.interface.c lex.cmatrix.c *.so* *.dylib* *.a
+	$(RM) foma flookup cgflookup $(FOMAOBJS) $(LIBOBJS) flookup.o cgflookup.o regex.h regex.c regex.output lex.yy.c lex.lexc.c lex.interface.c lex.cmatrix.c *.so* *.dylib* *.a libfoma.pc

=== debian/changelog ===
foma (1:0.10.0-1) unstable; urgency=low

  [ Tino Didriksen ]
  * New upstream release:
    + Adds runtime options interface.
    + Fixes numerous memory leaks and segfaults. (Closes: #958291)
    + Added patch to fix Blhc failures.
  * debian/control:
    + Swap libfoma0-dev and libfoma-dev.

  [ Kartik Mistry ]
  * Updated Standards-Version to 4.6.0

 -- Kartik Mistry <kartik@debian.org>  Thu, 24 Feb 2022 19:49:05 +0530

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: foma
 Section: science
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
            Timo Jyrinki <timo@debian.org>,
            Kartik Mistry <kartik@debian.org>
@@ -10,12 +10,12 @@
                flex,
                libreadline-dev,
                libtinfo-dev,
-               libtool,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://fomafst.github.io/
 Vcs-Git: https://salsa.debian.org/science-team/foma.git
 Vcs-Browser: https://salsa.debian.org/science-team/foma
+Rules-Requires-Root: no
 
 Package: foma
 Architecture: any
@@ -40,12 +40,12 @@
  .
  This package provides runtime libraries for foma.
 
-Package: libfoma0-dev
+Package: libfoma-dev
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}
-Breaks: libfoma-dev (<< 1:0)
-Replaces: libfoma-dev (<< 1:0)
+Breaks: libfoma0-dev (<< 1:0.10.0)
+Replaces: libfoma0-dev (<< 1:0.10.0)
 Section: libdevel
 Description: Foma development files
  Compiler, programming language, and C library for
@@ -63,10 +63,10 @@
  This is dummy transitional package for foma. It can be
  safely remove.
 
-Package: libfoma-dev
+Package: libfoma0-dev
 Architecture: all
-Depends: libfoma0-dev (>= ${source:Version}), ${misc:Depends}
+Depends: libfoma-dev (>= ${source:Version}), ${misc:Depends}
 Section: oldlibs
-Description: Transitional package for libfoma0-dev
- This is dummy transitional package for libfoma0-dev. It can
+Description: Transitional package for libfoma-dev
+ This is dummy transitional package for libfoma-dev. It can
  be safely remove.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS
export LC_ALL=C.UTF-8

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install

	# Remove libtool and static library
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.la
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a

override_dh_missing:
	dh_missing --fail-missing

## foma 0.10.0%2Bs311

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,19 @@
 Source: foma
 Section: science
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
            Timo Jyrinki <timo@debian.org>,
            Kartik Mistry <kartik@debian.org>
-Build-Depends: bison,
+Build-Depends: dpkg-dev (>= 1.22.5), bison,
+               cmake,
                debhelper-compat (= 13),
                flex,
                libreadline-dev,
-               libtinfo-dev,
+               pkg-config,
                zlib1g-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://fomafst.github.io/
 Vcs-Git: https://salsa.debian.org/science-team/foma.git
 Vcs-Browser: https://salsa.debian.org/science-team/foma
@@ -19,7 +21,7 @@
 
 Package: foma
 Architecture: any
-Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libfoma0t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Breaks: foma-bin (<< 1:0)
 Replaces: foma-bin (<< 1:0)
 Description: Tools for constructing various finite-state automata
@@ -27,7 +29,10 @@
  constructing finite-state automata and transducers for
  various uses.
 
-Package: libfoma0
+Package: libfoma0t64
+Provides: ${t64:Provides}
+Replaces: libfoma0
+Breaks: libfoma0 (<< ${source:Version})
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -43,10 +48,11 @@
 Package: libfoma-dev
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}
+Depends: libfoma0t64 (= ${binary:Version}), ${misc:Depends}
 Breaks: libfoma0-dev (<< 1:0.10.0)
 Replaces: libfoma0-dev (<< 1:0.10.0)
 Section: libdevel
+Multi-Arch: same
 Description: Foma development files
  Compiler, programming language, and C library for
  constructing finite-state automata and transducers for

## foma 0.10.0%2Bs311.20250909

=== debian/control ===
Source: foma
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
           Timo Jyrinki <timo@debian.org>,
           Kartik Mistry <kartik@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               flex,
               libreadline-dev,
               pkgconf,
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://fomafst.github.io/
Vcs-Git: https://salsa.debian.org/science-team/foma.git
Vcs-Browser: https://salsa.debian.org/science-team/foma
Rules-Requires-Root: no

Package: foma
Architecture: any
Depends: libfoma0t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: foma-bin (<< 1:0)
Replaces: foma-bin (<< 1:0)
Description: Tools for constructing various finite-state automata
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.

Package: libfoma-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libfoma0t64 (= ${binary:Version}), ${misc:Depends}
Breaks: libfoma0-dev (<< 1:0.10.0)
Replaces: libfoma0-dev (<< 1:0.10.0)
Description: Foma development files
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides development headers and libraries
 for foma.

Package: libfoma0t64
Architecture: any
Section: libs
Multi-Arch: same
Provides: ${t64:Provides}
Replaces: libfoma0
Breaks: libfoma0 (<< ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Foma runtime libraries
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides runtime libraries for foma.

## foma 0.10.0+s311

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})

file(READ fomalib.h _VERSION_FILE)
string(REGEX REPLACE ".*MAJOR_VERSION ([0-9]+).*MINOR_VERSION ([0-9]+).*BUILD_VERSION ([0-9]+).*" "\\1.\\2.\\3" _VERSION ${_VERSION_FILE})

project(foma
	VERSION ${_VERSION}
	LANGUAGES C
	)

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_MACOSX_RPATH ON)

include(GNUInstallDirs)

if(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /utf-8 /std:c17 /permissive- /W4 /MP")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /O2")
	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

	add_definitions(-DYY_NO_UNISTD_H) # Prevent Flex generated code including unistd.h
else()
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-missing-field-initializers -Wno-deprecated -Wno-unused-parameter -fvisibility=hidden -fPIC")

	# Require latest possible C standard
	include(CheckCCompilerFlag)
	foreach(flag "-std=c2x" "-std=c18" "-std=c17" "-std=c11" "-std=c1x" "-std=c99")
		string(REGEX REPLACE "[^a-z0-9]" "" _flag ${flag})
		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
		if(COMPILER_SUPPORTS_${_flag})
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
			set(_ENABLED_C ${flag})
			break()
		endif()
	endforeach()
	if(NOT _ENABLED_C)
		message(FATAL_ERROR "Could not enable at least C99 - upgrade your compiler")
	endif()

	add_definitions(-D_GNU_SOURCE)
endif()

if(WIN32)
	add_definitions(-D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX)
endif()

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

# getopt & readline
find_path(GETOPT_INCLUDE getopt.h)
include_directories(${GETOPT_INCLUDE})
if(VCPKG_TOOLCHAIN)
	find_library(GETOPT_LIB NAMES getopt)
	add_definitions(-DHAVE_GETOPT_LONG)
else()
	set(GETOPT_LIB)

	find_package(PkgConfig REQUIRED)
	pkg_search_module(READLINE readline)
endif()
if(NOT READLINE_INCLUDE_DIRS)
	find_path(READLINE_INCLUDE_DIRS readline.h PATH_SUFFIXES readline REQUIRED)
	find_library(READLINE_LIBRARIES readline REQUIRED)
endif()
include_directories(${READLINE_INCLUDE_DIRS})

# zlib
find_path(ZLIB_INCLUDE zlib.h REQUIRED)
if(VCPKG_TOOLCHAIN)
	find_package(ZLIB REQUIRED)
	find_library(ZLIB_LIBRARIES z REQUIRED)
	set(ZLIB_LIBS ZLIB::ZLIB)
else()
	find_library(ZLIB_LIBRARIES z REQUIRED)
	set(ZLIB_LIBS ${ZLIB_LIBRARIES})
endif()
include_directories(${ZLIB_INCLUDE})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

BISON_TARGET(Bregex regex.y "${CMAKE_CURRENT_BINARY_DIR}/regex.c" COMPILE_FLAGS "-v")
FLEX_TARGET(Fregex regex.l "${CMAKE_CURRENT_BINARY_DIR}/lex.yy.c" COMPILE_FLAGS "-8")
FLEX_TARGET(Flexc lexc.l "${CMAKE_CURRENT_BINARY_DIR}/lex.lexc.c" COMPILE_FLAGS "-8 --prefix=lexc")
FLEX_TARGET(Finterface interface.l "${CMAKE_CURRENT_BINARY_DIR}/lex.interface.c" COMPILE_FLAGS "-8 --prefix=interface")
FLEX_TARGET(Fcmatrix cmatrix.l "${CMAKE_CURRENT_BINARY_DIR}/lex.cmatrix.c" COMPILE_FLAGS "-8 --prefix=cmatrix")

set(SOURCES
	foma.h
	fomalib.h
	fomalibconf.h
	lexc.h
	apply.c
	coaccessible.c
	constructions.c
	define.c
	determinize.c
	dynarray.c
	extract.c
	flags.c
	int_stack.c
	io.c
	lexcread.c
	mem.c
	minimize.c
	reverse.c
	rewrite.c
	sigma.c
	spelling.c
	stringhash.c
	structures.c
	topsort.c
	trie.c
	utf8.c
	${FLEX_Fregex_OUTPUTS}
	${FLEX_Flexc_OUTPUTS}
	${FLEX_Fcmatrix_OUTPUTS}
	${BISON_Bregex_OUTPUTS}
	)

add_library(foma-static STATIC ${SOURCES})
target_link_libraries(foma-static PUBLIC ${ZLIB_LIBS})
set_target_properties(foma-static PROPERTIES ARCHIVE_OUTPUT_NAME foma)

add_library(foma-shared SHARED ${SOURCES})
target_link_libraries(foma-shared PRIVATE ${ZLIB_LIBS})
set_target_properties(foma-shared PROPERTIES
	LIBRARY_OUTPUT_NAME foma RUNTIME_OUTPUT_NAME foma
	VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
if(NOT MSVC)
	set_target_properties(foma-shared PROPERTIES ARCHIVE_OUTPUT_NAME foma)
endif()

add_executable(foma-bin foma.c stack.c iface.c ${FLEX_Finterface_OUTPUTS})
target_link_libraries(foma-bin PRIVATE foma-static ${READLINE_LIBRARIES} ${GETOPT_LIB})
set_target_properties(foma-bin PROPERTIES RUNTIME_OUTPUT_NAME foma)

if(MSYS OR NOT WIN32)
	add_executable(flookup flookup.c)
	target_link_libraries(flookup PRIVATE foma-static ${GETOPT_LIB})
	install(TARGETS flookup RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

add_executable(cgflookup cgflookup.c)
target_link_libraries(cgflookup PRIVATE foma-static ${GETOPT_LIB})

configure_file(libfoma.pc.in libfoma.pc @ONLY)

# Install
install(TARGETS foma-static foma-shared ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES fomalib.h fomalibconf.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(TARGETS foma-bin cgflookup RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libfoma.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

=== debian/changelog ===
foma (1:0.10.0+s311-1) unstable; urgency=medium

  * Update to latest upstream git
    + Changed build system to CMake
  * Deleted all patches, as they're either upstreamed or no longer needed

 -- Tino Didriksen <tino@didriksen.cc>  Wed, 26 Oct 2022 13:41:14 +0200

foma (1:0.10.0-3) unstable; urgency=low

  * debian/patches/0001-Makefile-Fix-typo-when-generating-libfoma.pc.patch:
    + Added patch forwarded link.

 -- Kartik Mistry <kartik@debian.org>  Sat, 09 Apr 2022 16:41:02 +0530

foma (1:0.10.0-2) unstable; urgency=low

  * Added patch to fix reproducible-builds. Thanks Vagrant Cascadian
    <vagrant@reproducible-builds.org>. (Closes: #1006474)

 -- Kartik Mistry <kartik@debian.org>  Wed, 02 Mar 2022 17:21:19 +0530

=== debian/control ===
Source: foma
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
           Timo Jyrinki <timo@debian.org>,
           Kartik Mistry <kartik@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               flex,
               libreadline-dev,
               pkg-config,
               zlib1g-dev
Standards-Version: 4.6.1
Homepage: https://fomafst.github.io/
Vcs-Git: https://salsa.debian.org/science-team/foma.git
Vcs-Browser: https://salsa.debian.org/science-team/foma
Rules-Requires-Root: no

Package: foma
Architecture: any
Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: foma-bin (<< 1:0)
Replaces: foma-bin (<< 1:0)
Description: Tools for constructing various finite-state automata
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.

Package: libfoma0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Foma runtime libraries
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides runtime libraries for foma.

Package: libfoma-dev
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfoma0 (= ${binary:Version}), ${misc:Depends}
Breaks: libfoma0-dev (<< 1:0.10.0)
Replaces: libfoma0-dev (<< 1:0.10.0)
Section: libdevel
Description: Foma development files
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides development headers and libraries
 for foma.

Package: foma-bin
Architecture: all
Depends: foma (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package for foma
 This is dummy transitional package for foma. It can be
 safely remove.

Package: libfoma0-dev
Architecture: all
Depends: libfoma-dev (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package for libfoma-dev
 This is dummy transitional package for libfoma-dev. It can
 be safely remove.

## foma 0.10.0+s311.20240712

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 	# Require latest possible C standard
 	include(CheckCCompilerFlag)
-	foreach(flag "-std=c2x" "-std=c18" "-std=c17" "-std=c11" "-std=c1x" "-std=c99")
+	foreach(flag "-std=c18" "-std=c17" "-std=c11" "-std=c1x" "-std=c99")
 		string(REGEX REPLACE "[^a-z0-9]" "" _flag ${flag})
 		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})

=== debian/changelog ===
foma (1:0.10.0+s311.20240712-1) unstable; urgency=medium

  * Team upload.
  * Acknowledge NMU.
  * New upstream git snapshot on 2024-07-12. (Closes: #1074963)
  * debian/control: Apply "wrap-and-sort -abst".
  * debian/control: Replace build-dependency: pkg-config => pkgconf.
  * debian/control: Drop transitional package foma-bin, libfoma0-dev.
    (Closes: #1038227)

  [ Debian Janitor ]
  * debian/control: Apply multi-arch hints: libfoma-dev: Use Multi-Arch: same.

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Jul 2024 18:28:26 -0400

foma (1:0.10.0+s311-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061941

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:05:09 +0000

foma (1:0.10.0+s311-1.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Debian Janitor ]
  * Apply hints suggested by the multi-arch hinter.

  [ Tino Didriksen ]
  * Fixes for GCC 13 and Visual Studio (closes: #1037663)

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Mon, 31 Jul 2023 02:03:09 +0200

=== debian/control ===
Source: foma
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders:
 Tino Didriksen <mail@tinodidriksen.com>,
 Timo Jyrinki <timo@debian.org>,
 Kartik Mistry <kartik@debian.org>,
Build-Depends:
 bison,
 cmake,
 dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 flex,
 libreadline-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://fomafst.github.io/
Vcs-Git: https://salsa.debian.org/science-team/foma.git
Vcs-Browser: https://salsa.debian.org/science-team/foma
Rules-Requires-Root: no

Package: foma
Architecture: any
Depends:
 libfoma0t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 foma-bin (<< 1:0),
Replaces:
 foma-bin (<< 1:0),
Description: Tools for constructing various finite-state automata
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.

Package: libfoma-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libfoma0t64 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libfoma0-dev (<< 1:0.10.0),
Replaces:
 libfoma0-dev (<< 1:0.10.0),
Description: Foma development files
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides development headers and libraries
 for foma.

Package: libfoma0t64
Architecture: any
Section: libs
Multi-Arch: same
Provides: ${t64:Provides}
Replaces: libfoma0
Breaks: libfoma0 (<< ${source:Version})
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Foma runtime libraries
 Compiler, programming language, and C library for
 constructing finite-state automata and transducers for
 various uses.
 .
 This package provides runtime libraries for foma.

## foma 0.10.0+s311.20250909

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
 file(READ fomalib.h _VERSION_FILE)
@@ -26,7 +26,7 @@
 
 	# Require latest possible C standard
 	include(CheckCCompilerFlag)
-	foreach(flag "-std=c18" "-std=c17" "-std=c11" "-std=c1x" "-std=c99")
+	foreach(flag "-std=c2y" "-std=c23" "-std=c2x" "-std=c18" "-std=c17" "-std=c11" "-std=c1x" "-std=c99")
 		string(REGEX REPLACE "[^a-z0-9]" "" _flag ${flag})
 		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
@@ -61,23 +61,33 @@
 	find_package(PkgConfig REQUIRED)
 	pkg_search_module(READLINE readline)
 endif()
-if(NOT READLINE_INCLUDE_DIRS)
-	find_path(READLINE_INCLUDE_DIRS readline.h PATH_SUFFIXES readline REQUIRED)
-	find_library(READLINE_LIBRARIES readline REQUIRED)
+
+# Only look for readline if not building for WASM
+if(NOT EMSCRIPTEN)
+    if(NOT READLINE_INCLUDE_DIRS)
+        find_path(READLINE_INCLUDE_DIRS readline.h PATH_SUFFIXES readline REQUIRED)
+        find_library(READLINE_LIBRARIES readline REQUIRED)
+    endif()
+    include_directories(${READLINE_INCLUDE_DIRS})
 endif()
-include_directories(${READLINE_INCLUDE_DIRS})
 
-# zlib
-find_path(ZLIB_INCLUDE zlib.h REQUIRED)
-if(VCPKG_TOOLCHAIN)
-	find_package(ZLIB REQUIRED)
-	find_library(ZLIB_LIBRARIES z REQUIRED)
-	set(ZLIB_LIBS ZLIB::ZLIB)
+# zlib handling
+if(EMSCRIPTEN)
+    # Emscripten-specific zlib handling
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --use-port=zlib")
+    set(ZLIB_LIBS "")
 else()
-	find_library(ZLIB_LIBRARIES z REQUIRED)
-	set(ZLIB_LIBS ${ZLIB_LIBRARIES})
+    find_path(ZLIB_INCLUDE zlib.h REQUIRED)
+    if(VCPKG_TOOLCHAIN)
+        find_package(ZLIB REQUIRED)
+        find_library(ZLIB_LIBRARIES z REQUIRED)
+        set(ZLIB_LIBS ZLIB::ZLIB)
+    else()
+        find_library(ZLIB_LIBRARIES z REQUIRED)
+        set(ZLIB_LIBS ${ZLIB_LIBRARIES})
+    endif()
+    include_directories(${ZLIB_INCLUDE})
 endif()
-include_directories(${ZLIB_INCLUDE})
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
@@ -133,23 +143,57 @@
 	set_target_properties(foma-shared PROPERTIES ARCHIVE_OUTPUT_NAME foma)
 endif()
 
-add_executable(foma-bin foma.c stack.c iface.c ${FLEX_Finterface_OUTPUTS})
-target_link_libraries(foma-bin PRIVATE foma-static ${READLINE_LIBRARIES} ${GETOPT_LIB})
-set_target_properties(foma-bin PROPERTIES RUNTIME_OUTPUT_NAME foma)
+# WASM-specific target
+if(EMSCRIPTEN)
+    # Create WASM library target
+    add_executable(libfoma ${SOURCES})
+    target_link_libraries(libfoma PRIVATE ${ZLIB_LIBS})
 
-if(MSYS OR NOT WIN32)
-	add_executable(flookup flookup.c)
-	target_link_libraries(flookup PRIVATE foma-static ${GETOPT_LIB})
-	install(TARGETS flookup RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    # Emscripten-specific link flags - export all fomalib functions
+    set(EXPORTED_FUNCTIONS
+        "[\'_malloc\',\'_free\',\'_defined_networks_init\',\'_defined_functions_init\',\'_add_defined\',\'_add_defined_function\',\'_fsm_construct_init\',\'_fsm_construct_set_final\',\'_fsm_construct_set_initial\',\'_fsm_construct_add_arc\',\'_fsm_construct_add_arc_nums\',\'_fsm_construct_add_symbol\',\'_fsm_construct_check_symbol\',\'_fsm_construct_copy_sigma\',\'_fsm_construct_done\',\'_fsm_parse_regex\',\'_fsm_create\',\'_fsm_empty\',\'_fsm_empty_set\',\'_fsm_universal\',\'_fsm_identity\',\'_fsm_contains\',\'_fsm_contains_one\',\'_fsm_contains_opt_one\',\'_fsm_minimize\',\'_fsm_determinize\',\'_fsm_epsilon_remove\',\'_fsm_reverse\',\'_fsm_invert\',\'_fsm_lower\',\'_fsm_upper\',\'_fsm_kleene_star\',\'_fsm_kleene_plus\',\'_fsm_optionality\',\'_fsm_concat\',\'_fsm_union\',\'_fsm_intersect\',\'_fsm_compose\',\'_fsm_complement\',\'_fsm_minus\',\'_fsm_simple_replace\',\'_fsm_context_restrict\',\'_fsm_isempty\',\'_fsm_isfunctional\',\'_fsm_isidentity\',\'_fsm_destroy\',\'_fsm_copy\',\'_fsm_complete\',\'_apply_init\',\'_apply_clear\',\'_apply_up\',\'_apply_down\',\'_apply_words\',\'_apply_upper_words\',\'_apply_lower_words\',\'_apply_random_words\',\'_apply_random_upper\',\'_apply_random_lower\',\'_fsm_get_library_version_string\',\'_fsm_set_option\',\'_fsm_get_option\',\'_fsm_read_binary_file\',\'_fsm_write_binary_file\',\'_fsm_trie_init\',\'_fsm_trie_done\',\'_fsm_trie_add_word\',\'_fsm_trie_end_word\',\'_sigma_copy\',\'_fsm_sigma_destroy\',\'_fsm_merge_sigma\']")
+
+    set_target_properties(libfoma PROPERTIES
+        SUFFIX ".js"
+        LINK_FLAGS "-s WASM=1 \
+                   -s EXPORTED_RUNTIME_METHODS=[\'ccall\',\'cwrap\',\'stringToUTF8\',\'UTF8ToString\'] \
+                   -s EXPORTED_FUNCTIONS=${EXPORTED_FUNCTIONS} \
+                   -s ENVIRONMENT=web"
+    )
+
+    # Add custom target to clean WASM-generated files
+    set(WASM_GENERATED_FILES
+        ${CMAKE_CURRENT_BINARY_DIR}/libfoma.js
+        ${CMAKE_CURRENT_BINARY_DIR}/libfoma.wasm
+    )
+
+    set_directory_properties(PROPERTIES
+        ADDITIONAL_CLEAN_FILES "${WASM_GENERATED_FILES}"
+    )
+
+    install(TARGETS libfoma RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+else()
+    # Regular foma-bin target
+    add_executable(foma-bin foma.c stack.c iface.c ${FLEX_Finterface_OUTPUTS})
+    target_link_libraries(foma-bin PRIVATE foma-static ${READLINE_LIBRARIES} ${GETOPT_LIB})
+    target_link_directories(foma-bin PRIVATE ${READLINE_LIBRARY_DIRS})
+    set_target_properties(foma-bin PROPERTIES RUNTIME_OUTPUT_NAME foma)
+
+	if(MSYS OR NOT WIN32)
+		add_executable(flookup flookup.c)
+		target_link_libraries(flookup PRIVATE foma-static ${GETOPT_LIB})
+		install(TARGETS flookup RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+	endif()
+
+	add_executable(cgflookup cgflookup.c)
+	target_link_libraries(cgflookup PRIVATE foma-static ${GETOPT_LIB})
+
+	configure_file(libfoma.pc.in libfoma.pc @ONLY)
+
+	# Install
+	install(TARGETS foma-static foma-shared ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+	install(FILES fomalib.h fomalibconf.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+	install(TARGETS foma-bin cgflookup RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libfoma.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
+
 endif()
-
-add_executable(cgflookup cgflookup.c)
-target_link_libraries(cgflookup PRIVATE foma-static ${GETOPT_LIB})
-
-configure_file(libfoma.pc.in libfoma.pc @ONLY)
-
-# Install
-install(TARGETS foma-static foma-shared ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-install(FILES fomalib.h fomalibconf.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-install(TARGETS foma-bin cgflookup RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libfoma.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

=== debian/changelog ===
foma (1:0.10.0+s311.20250909-1) unstable; urgency=medium

  * Upstream fixes for various GCC15 and CMake versions (Closes: #1112925)
  * Snip patches that are merged upstream

 -- Tino Didriksen <tino@didriksen.cc>  Thu, 11 Sep 2025 09:00:01 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS
export LC_ALL=C.UTF-8

export "DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto"
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR) -type f -name '*.a' -exec rm -f '{}' \;

=== debian/watch ===
version=4
opts="searchmode=plain" \
  https://api.github.com/repos/mhulden/@PACKAGE@/releases \
  https://github.com/mhulden/@PACKAGE@/releases/download/v(?:\d[\d.]*)/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
